package com.persagy.dmp.rwd.edit.service;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.CriteriaUtils;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.edit.config.web.UserUtils;
import com.persagy.dmp.rwd.edit.entity.QRwdeditVersion;
import com.persagy.dmp.rwd.edit.entity.RwdeditVersion;
import com.persagy.dmp.rwd.edit.entity.RwdeditVersionChangeRecord;
import com.persagy.dmp.rwd.edit.repository.RwdeditVersionChangeRecordRepository;
import com.persagy.dmp.rwd.edit.repository.RwdeditVersionRepository;
import com.querydsl.core.types.dsl.BooleanExpression;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Service
public class RwdeditVersionService {

    @Autowired
    private CriteriaUtils criteriaUtils;

    @Autowired
    private RwdeditVersionRepository repository;

    @Autowired
    private RwdeditVersionChangeRecordRepository changeRecordRepository;

    private List<BooleanExpression> parse(ObjectNode criteria) {
        // TODO
        return null;
    }

    public PagedResponse<RwdeditVersion> query(JacksonCriteria criteria) {
        return criteriaUtils.query(QRwdeditVersion.rwdeditVersion, this::parse, criteria);
    }

    @Transactional
    public MapResponse create(RwdeditVersion param) {
        MapResponse response = new MapResponse();
        // TODO
        String version = param.getVersion();
        if (version == null) {
            response.setFail("版本编号不可为空!");
            return response;
        }
        long count = repository.count(QRwdeditVersion.rwdeditVersion.version.eq(version));
        if (count > 0) {
            response.setFail("版本编号已存在!");
            return response;
        }

        RwdeditVersion entity = new RwdeditVersion();
        entity.setVersion(version);
        entity.setCreateTime(new Date());
        entity.setCreateUser(UserUtils.currentUserId() + "");
        repository.save(entity);
        response.add("id", entity.getVersion());
        return response;
    }

    @Transactional
    public MapResponse infoAddVersion(List<Integer> infoIdList, String versionId, Integer type) {
        MapResponse response = new MapResponse();
        List<RwdeditVersionChangeRecord> data = new ArrayList<>();
        for (Integer infoId : infoIdList) {
            RwdeditVersionChangeRecord entity = new RwdeditVersionChangeRecord();
            entity.setVersionId(versionId);
            entity.setChangeId(infoId);
            entity.setType(type);
            data.add(entity);
        }
        changeRecordRepository.saveAll(data);
        return response;
    }
}

